import es
import playerlib
import cmdlib
import popuplib
import soccer.soccer as soccerlib
import psyco
import services
psyco.full()

info = es.AddonInfo()
info.name = "Soccer Team Skins Script"
info.version = soccerlib.info.version
info.basename = "soccerteamskins2"
info.author = "chrismrulz"

tskin = soccerlib.config["Skins"]["tskin"]
ctskin = soccerlib.config["Skins"]["ctskin"]
tskinname = soccerlib.config["Skins"]["tskin"]
ctskinname = soccerlib.config["Skins"]["ctskin"]
awaychar = soccerlib.config["Skins"]["awaychar"]
skins = soccerlib.config["Skins"]

teamselect = 0
oneteamselect = 0

def loadblock():
	if(es.exists('saycommand', '!skin') != 1):
		cmdlib.registerSayCommand('!skin', skinsmenu, 'Shows the skin menu', 'use_ref', 'ADMIN')
	if(es.exists('clientcommand', 'skin') != 1):
		cmdlib.registerClientCommand('skin', skinsmenu, 'Shows the skin menu', 'use_ref', 'ADMIN')
	for tagname in skins:
		if(tagname != 'awaychar'):
			es.stringtable('downloadables', skins[tagname])
	es.msg("#Green", "Soccer Team Skins Script On - by Gideon / Toph")

def setup_auth():
    global isAuthed
    if services.isRegistered('auth'):
        auth_service = services.use('auth')
        auth_service.registerCapability('skin', auth_service.ADMIN)
        isAuthed = lambda x: auth_service.isIdAuthorized(x, 'skin')
    else:
        isAuthed = lambda x: False

def load():
	setup_auth()
	loadblock()

def es_map_start(event_var):
	loadblock()

def unload():
	cmdlib.unregisterClientCommand('skin')
	cmdlib.unregisterSayCommand('!skin')
	es.msg("#Green", "Soccer Team Skins Script Off")

def skinsmenu(userid, args):
	skPopup = popuplib.easymenu('Team Skins Menu', None, sk_option)
	skPopup.addoption('skinselect', 'Select both team skins')
	skPopup.addoption('ctselect', 'Select CT skin')
	skPopup.addoption('tselect', 'Select T skin')
	skPopup.addoption('skinsremove', 'Remove team skins')
	skPopup.send(userid)

def sk_option(userid, choice, popupname):
	if(choice == 'skinsremove'):
		global teamselect
		teamselect = 0
		tskinname = soccerlib.config["Skins"]["tskin"]
		ctskinname = soccerlib.config["Skins"]["ctskin"]
		for players in playerlib.getPlayerList('#all,!un,!spec'):
			team = players.team
			parseskins(userid, team)
		es.tell(userid, "#green", "Team skins have been removed.")
	else:
		skins_select(userid, choice)

def skins_select(userid, choice):
	global teamselect
	global oneteamselect
	global skinsselect
	global teamchoice
	skinsselect = popuplib.easymenu('skinsselect', None, skinschosen)
	if(choice == 'skinselect'):
		oneteamselect = 0
		teamselect = 3
	elif(oneteamselect == 0):
		teamselect = 2
	skinsselect.settitle('Teams')
	if(choice == 'ctselect'):
		oneteamselect = 1
		teamselect = 3
	elif(choice == 'tselect'):
		oneteamselect = 1
		teamselect = 2
	for tagname in skins:
		tagname = unicode(tagname)
		if(tagname != 'ctskin' and tagname != 'tskin' and tagname != 'awaychar' and awaychar not in tagname):
			skinsselect.addoption(tagname, tagname)
	if(teamselect == 3):
		teamchoice = "ct"
	elif(teamselect == 2):
		teamchoice = "t"
	team_select(userid, teamchoice)
	skinsselect.send(userid)

def team_select(userid, team):
	es.tell(userid, "#multi", "#greenSelect the #lightgreen%s #greenteam skin." % team.upper())
				
def skinschosen(userid, choice, popupname):
	global tagname
	tagname = choice
	if(tagname + awaychar not in skins):
		global tagname
		tagname1 = tagname.encode('utf8')
		if(teamselect == 3):
			global ctskinname
			ctskinname = skins[tagname]
		elif(teamselect == 2):
			global tskinname
			tskinname = skins[tagname]
		es.msg('#multi', "#greenThe #lightgreen%s #greenteam has been assigned the #lightgreen%s #greenskin." % (teamchoice.upper(), tagname1))
		parseskins(userid, teamselect)
		if(teamselect == 3 and oneteamselect == 0):
			skins_select(userid, choice=0)
	else:
		skinsha = popuplib.easymenu('skinshaselect', None, fskinchosen)
		skinsha.settitle('Choose Home or Away Kit')
		skinsha.addoption('Home', 'Home')
		skinsha.addoption('Away', 'Away')
		skinsha.send(userid)

def fskinchosen(userid, choice, popupname):
	global tagname
	tagname1 = tagname.encode('utf8')
	if(choice == 'Away'):
		tagname = tagname + awaychar
	if(teamselect == 3):
		global ctskinname
		ctskinname = skins[tagname]
	elif(teamselect == 2):
		global tskinname
		tskinname = skins[tagname]
	es.msg('#multi', "#greenThe #lightgreen%s #greenteam has been assigned the #lightgreen%s #green%s skin." % (teamchoice.upper(), tagname1, choice))
	parseskins(userid, teamselect)
	if(teamselect == 3 and oneteamselect == 0):
		skins_select(userid, choice=0)

def parseskins(userid, team):
	toset = ""
	skin = ""
	if(team == 2):
		players = playerlib.getPlayerList('#t')
		goalie = es.ServerVar('tgoalie')
		skin = tskin
		skinname = tskinname
	elif(team == 3):
		players = playerlib.getPlayerList('#ct')
		goalie = es.ServerVar('ctgoalie')
		skin = ctskin
		skinname = ctskinname
	for player in players:
		toset = skinname
		if(player.steamid == 'BOT'):
			if(player.userid != goalie):
				if(teamselect != 0):
					playerlib.getPlayer(player.userid).setModel(toset)
				else:
					playerlib.getPlayer(player.userid).setModel(skin)
		elif(player.steamid != goalie):
			if(teamselect != 0):
				playerlib.getPlayer(player.userid).setModel(toset)
			else:
				playerlib.getPlayer(player.userid).setModel(skin)

def player_spawn(event_var):
	parseskins(int(event_var['userid']), int(event_var['es_userteam']))